__KERN_VMA_BASE = 0xfffffff000000000;
__PHY_DRAM_START_ADDR = 0x40000000;
__PHY_START_LOAD_ADDR = 0x40010000;

ENTRY(__PHY_START_LOAD_ADDR)
SECTIONS
{
    . = __KERN_VMA_BASE + __PHY_START_LOAD_ADDR;
    .text.boot : AT(__PHY_START_LOAD_ADDR) { KEEP(*(.text.boot)) }
    .text :
    {
        KEEP(*(.text.boot))
        *(.text.exceptions)
        . = ALIGN(4096); /* align for exceptions_vector_table*/
        *(.text.exceptions_vector_table)
        *(.text)
    }
    . = ALIGN(0x1000);

    LD_DATA_BASE = .;
    .data : { *(.data*) }
    . = ALIGN(0x1000);

    LD_RODATA_BASE = .;
    .rodata : { *(.rodata*) }
    . = ALIGN(0x1000);

    LD_BSS_BASE = .;
    .bss :
    { 
        *(.bss*)
        . = ALIGN(4096);
        . += (4096 * 100); /* 栈的大小 */
        stack_top = .;
        LD_STACK_PTR = .;
    }

    /* 页表 */
    .pt :
        {
        . = ALIGN(4096);

        /* 页表基地址TTBR0 */
        LD_TTBR0_BASE = . - __KERN_VMA_BASE;
        . = . + 0x1000;

        /* 页表基地址TTBR1 */
        LD_TTBR1_BASE = . - __KERN_VMA_BASE;
        . = . + 0x1000;
        }

    . = . + 0x1000;
    LD_KERNEL_END = . - __KERN_VMA_BASE;
}